from rest_framework import serializers
from .models import Lecture

class LectureSerializer(serializers.Serializer):
    lectureid = serializers.CharField(max_length=50)
    topic = serializers.CharField(max_length=100)
    date = serializers.CharField(max_length=50)
    duration = serializers.CharField(max_length=100)
    recording = serializers.CharField(max_length=10000)
    summary = serializers.CharField(max_length=10000)

    def create(self, validated_data):
        return Lecture.objects.create(validated_data)

    def update(self, instance, validated_data):
        instance.lectureid = validated_data.get('lectureid',instance.lectureid)
        instance.topic = validated_data.get('topic', instance.topic)
        instance.date = validated_data.get('date', instance.date)
        instance.duration = validated_data.get('duration', instance.duration)
        instance.recording = validated_data.get('recording', instance.recording)
        instance.summary = validated_data.get('summary', instance.summary)
        instance.save()
        return instance