from django.shortcuts import render
from django.http import HttpResponse, JsonResponse
from rest_framework.parsers import JSONParser
from.models import Lecture
from .serializers import LectureSerializer
from django.views.decorators.csrf import csrf_exempt
from rest_framework.decorators import api_view
from rest_framework.response import Response
from rest_framework import status

# Create your views here.

@api_view(['GET', 'POST'])
def lecture_list(request):
    if request.method =="GET":
        lectures = Lecture.objects.all()
        serializer = LectureSerializer(lectures, many=True)
        return Response(serializer.data)

    elif request.method=="POST":
        serializer = LectureSerializer(data=request.data)
        if serializer.is_valid():
            serializer.save()
            return Response(serializer.data, status=status.HTTP_201_CREATED)
        return JsonResponse(serializer.data, status=status.HTTP_400_BAD_REQUEST)

@api_view(['GET','PUT','DELETE'])
def lecture_details(request,pk):
    try:
        lecture = Lecture.objects.get(pk=pk)
    except Lecture.DoesNotExist:
        return Response(status =status.HTTP_404_NOT_FOUND)

    if request.method=='GET':
        serializer = LectureSerializer(lecture)
        return Response(serializer.data)

    elif request.method =='PUT':
        serializer = LectureSerializer(data=request.data)
        if serializer.is_valid():
            serializer.save()
            return Response(serializer.data)
        return Response(serializer.data, status=status.HTTP_404_NOT_FOUND)

    elif request.method =='DELETE':
        lecture.delete()
        return Response(status=status.HTTP_204_NO_CONTENT)
