import bs4 as bs
import urllib.request
import re
import nltk

scraped_data = urllib.request.urlopen('https://www.guru99.com/java-oops-concept.html')
lecture = scraped_data.read()

parsed_lecture = bs.BeautifulSoup(lecture,'lxml')

paragraphs = parsed_lecture.find_all('p')

lecture_text = ""

for p in paragraphs:
    lecture_text += p.text

lecture_text = re.sub(r'\[[0-9]*\]', ' ', lecture_text)
lecture_text = re.sub(r'\s+', ' ', lecture_text)

formatted_lecture_text = re.sub('[^a-zA-Z]', ' ', lecture_text )
formatted_lecture_text = re.sub(r'\s+', ' ', formatted_lecture_text)

sentence_list = nltk.sent_tokenize(lecture_text)

stopwords = nltk.corpus.stopwords.words('english')

word_frequencies = {}
for word in nltk.word_tokenize(formatted_lecture_text):
    if word not in stopwords:
        if word not in word_frequencies.keys():
            word_frequencies[word] = 1
        else:
            word_frequencies[word] += 1

maximum_frequncy = max(word_frequencies.values())

for word in word_frequencies.keys():
    word_frequencies[word] = (word_frequencies[word]/maximum_frequncy)


sentence_scores = {}
for sent in sentence_list:
    for word in nltk.word_tokenize(sent.lower()):
        if word in word_frequencies.keys():
            if len(sent.split(' ')) < 30:
                if sent not in sentence_scores.keys():
                    sentence_scores[sent] = word_frequencies[word]
                else:
                    sentence_scores[sent] += word_frequencies[word]

import heapq
summary_sentences = heapq.nlargest(20, sentence_scores, key=sentence_scores.get)

summary = ' '.join(summary_sentences)
print(summary)